// GnuCiPlot //
// Author: Klaus-Dieter Liss //
// Date: 2016.07.23 //


function [Gf]=gNew(fn)
    global GSP_fn GSP_act ;
    gKill(fn);
    Gf.figure = fn;
    Gf.index = -1;
    Gf.open = 1;
    pid = getpid();
    Gf.pid = pid;
    Gf.fifo = sprintf("/tmp/%d.%d.gnusciplot-pipe", Gf.pid, Gf.figure);
    Gf.data = sprintf("/tmp/%d.%d.gnusciplot-data", Gf.pid, Gf.figure);
    Gf.keep = 0;
    [Gf.u_return,Gf.u_status] = unix_g("mkfifo -m 666 " + Gf.fifo);
//    Gf.x_command = sprintf("nohup gnuplot  <%s & " ,Gf.fifo);
    Gf.x_command = sprintf("while :; do (gnuplot -persist) < %s ; done &" ,Gf.fifo);
    [Gf.x_return,Gf.x_status,Gf.x_stderr] = unix_g(Gf.x_command);
    Gf.fd = mopen(Gf.fifo,"a");
    GSP_fn(Gf.figure) = Gf;
    GSP_act = Gf;
    [Gf]=gListSet();
    Gf=gDefault();
endfunction

function [Gf]=gKill(fn)
    global GSP_list GSP_fn GSP_act ;
    G = gListFind(fn);
    if (G <> []) then
       ind = G.index;
       GSP_act = G;
       gKillAct();
       jj=0; Gl=[];
       for ii=1:(ind-1),
       	   jj = jj+1;
	   Gl(jj) = GSP_list(ii);
	   end;
       for ii=(ind+1):(size(GSP_list,1)),
       	   jj = jj+1;
	   Gl(jj) = GSP_list(ii);
	   end;
//       Gl = GSP_list([1:(ind-1),(ind+1):size(GSP_list,1)]);
       GSP_list = Gl;
       end;
    Gf = GSP_act;
endfunction

function [Gf]=gKillAll()
    global GSP_list GSP_fn GSP_act ;
    nn = size(GSP_list,1);
    Gf=[];
    for ii=1:nn,
    	[Gf]=gKill(ii);	
	end;
endfunction


function [all]=gShowAll()
    global GSP_list GSP_fn GSP_act ;
    nn = size(GSP_list,1);
    all=[];
    for ii=1:nn,
    	all(ii)=GSP_list(ii).figure;
	end;
//    all = gsort(all,'g','i');
endfunction


function [Gf]=gListFind(fn)
    global GSP_list GSP_fn GSP_act ;
    Gf = [];
    nn = size(GSP_list,1);
    for ii=1:nn,
    	if (GSP_list(ii).figure == fn) then
	   Gf=GSP_list(ii);
    	   GSP_act=Gf;
	   end;
	end;
endfunction

function [Gf]=gListSet()
    global GSP_list GSP_fn GSP_act ;
    Gf=GSP_act;
    G = gListFind(GSP_act.figure);
    if (G == []) then
       nn = size(GSP_list,1);
       GSP_act.index = nn + 1;
       GSP_list(nn+1) = GSP_act;
       Gf = GSP_act;
       end;
endfunction

function [Gf]=gListDel()
    global GSP_list GSP_fn GSP_act ;
    Gf = gListFind(GSP_act.figure);
    if (Gf == []) then
       nn = size(GSP_list,1);
       GSP_list(nn+1) = GSP_act;
       Gf = GSP_act;
       end;
endfunction


function [Gf]=gCommand(str)
    global GSP_fn GSP_act ;
    Gf = GSP_act;
    mputl(str, Gf.fd);
    mgetl(Gf.fd);
    Gf.g_command = str;
    GSP_fn(Gf.figure) = Gf;
    GSP_act = Gf;
endfunction

function [Gf]=gDefault()
    global GSP_fn GSP_act ;
    Gf = GSP_act;
    Gf=gCommand("reset;");
    [Gf]=gCommand(sprintf("set term pop title ""gnuscifig %d""",Gf.figure));
    [Gf]=gCommand("set tics out; set mxtics; set mytics; set tics font "",12""; ");
    [Gf]=gCommand("set title  font "",16""; ");
    [Gf]=gCommand("set xlabel font "",14""; ");
    [Gf]=gCommand("set ylabel font "",14""; ");
    [Gf]=gCommand("set tics   font "",12""; ");
    [Gf]=gCommand("set palette rgbformulae 33,13,10; ");
    GSP_act = Gf;
    GSP_fn(Gf.figure) = Gf;
endfunction

function [Gf]=gClear()
    global GSP_fn GSP_act ;
    Gf = GSP_act;
	 Gf=gCommand("clear;");
    GSP_act = Gf;
    GSP_fn(Gf.figure) = Gf;
endfunction


function [Gf]=gGetGf(fn)
    global GSP_fn
    global GSP_fn GSP_act ;
    Gf = GSP_act;
    Gf = GSP_fn(fn);
    GSP_act = Gf;
    GSP_fn(Gf.figure) = Gf;
endfunction


function [Gf]=gTitle(str)
    global GSP_fn GSP_act ;
    Gf = GSP_act;
	 Gf=gCommand(sprintf("set title ""%s""",str));
    GSP_act = Gf;
    GSP_fn(Gf.figure) = Gf;
endfunction

function [Gf]=gXlabel(str)
    global GSP_fn GSP_act ;
    Gf = GSP_act;
	 Gf=gCommand(sprintf("set xlabel ""%s""",str));
    GSP_act = Gf;
    GSP_fn(Gf.figure) = Gf;
endfunction

function [Gf]=gYlabel(str)
    global GSP_fn GSP_act ;
    Gf = GSP_act;
	 Gf=gCommand(sprintf("set ylabel ""%s""",str));
    GSP_act = Gf;
    GSP_fn(Gf.figure) = Gf;
endfunction

function [Gf]=gReplot()
    global GSP_fn GSP_act ;
    Gf = GSP_act;
	 Gf=gCommand("replot");
    GSP_act = Gf;
    GSP_fn(Gf.figure) = Gf;
endfunction

function [Gf]=gPlotY(y)
    global GSP_fn GSP_act ;
    Gf = GSP_act;
	 py = matrix(y,length(y),1);
	 [Gf]=gCommand("set tics out; set mxtics; set mytics; set tics font "",12""; ");
	 [Gf]=gCommand("plot ""-"" with lines notitle ;");
	 format('v',18);
	 for ii=1:size(py,1),
	     mputl(strcat(string(py(ii,:))+' '),Gf.fd);
	     end;
	 [Gf]=gCommand("end");
    GSP_act = Gf;
    GSP_fn(Gf.figure) = Gf;
endfunction

function [Gf]=gMPlot(x,y,py)
    global GSP_fn GSP_act ;
    Gf = GSP_act;
         [sy,sx]=size(py);
	 [x,y]=gSaveBinaryMatrix(Gf.data,x,y,py);
	 [Gf]=gCommand("set pm3d map");
	 [Gf]=gCommand(sprintf("set xrange [%g:%g] noreverse nowriteback",min(x),max(x)));
	 [Gf]=gCommand(sprintf("set yrange [%g:%g] noreverse nowriteback",min(y),max(y)));
	 [Gf]=gCommand(sprintf("plot ""%s"" binary matrix with image;",Gf.data));
	 mdelete(Gf.data);
    GSP_act = Gf;
    GSP_fn(Gf.figure) = Gf;
endfunction

function [Gf]=gRSMap(x,y,z)
    global GSP_fn GSP_act ;
    Gf = GSP_act;
         [sy,sx]=size(z);
	 gSaveParametricDataXYZ(Gf.data,x,y,z);
	 [Gf]=gCommand("set pm3d map interpolate 1,1;");
	 [Gf]=gCommand("set size ratio -1;");
	 [Gf]=gCommand("unset colorbox");
	 [Gf]=gCommand("");
	 [Gf]=gCommand("");
	 [Gf]=gCommand(sprintf("splot ""%s"" notitle;",Gf.data));
	 if (Gf.keep == 0) then 
	     mdelete(Gf.data);
	     end;
    GSP_act = Gf;
    GSP_fn(Gf.figure) = Gf;
endfunction

function [Gf]=gPlotXY(py)
    global GSP_fn GSP_act ;
    Gf = GSP_act;
         [sy,sx]=size(py);
	 SaveTxtMat(Gf.data,py);
	 if (sx > 2.0) then
 	       [Gf]=gCommand(sprintf("plot for [col=2:%d] ""%s"" u 1:col w lines notitle ;",sx,Gf.data));
	     else
	       [Gf]=gCommand(sprintf("plot ""%s"" w lines notitle ;", Gf.data));
             end
	 [Gf]=gCommand("end");
	 sleep(400);
	 mdelete(Gf.data);
    GSP_act = Gf;
    GSP_fn(Gf.figure) = Gf;
endfunction

function [Gf] = gPsDump(nam);
    global GSP_fn GSP_act ;
    Gf = GSP_act;
    gCommand("set term push");
    gCommand("set term postscript landscape enhanced color dashed ""Helvetica"" 14");
    str = sprintf("set output ""%s""; ",nam);
    gCommand(str);
    gReplot();
    gCommand("set term pop");
    Gf.g_command = str;
    GSP_act = Gf;
    GSP_fn(Gf.figure) = Gf;
endfunction

function [Gf] = old_gPsDump(fn,nam);
    global GSP_fn GSP_act ;
    Gf = gGetGf(fn);
    str = sprintf("set term postscript; set output ""%s""; ",nam);
    mputl(str, Gf.fd);
    mputl("set term postscript landscape enhanced color dashed ""Helvetica"" 14",  Gf.fd);
    mputl("replot", Gf.fd);
    mputl("set term pop", Gf.fd);
    mgetl(Gf.fd);
    Gf.g_command = str;
    GSP_fn(Gf.figure) = Gf;
    GSP_act = Gf;
endfunction

function [Gf]=gPlotSin1()
    global GSP_fn GSP_act ;
    Gf = GSP_act;
    fd=mopen(Gf.fifo,"a");
    mputl("plot sin(1*x)",fd); 
    mgetl(fd);
    GSP_act = Gf;
    GSP_fn(Gf.figure) = Gf;
endfunction

function [Gf]=gKillAct()
    global GSP_fn GSP_act ;
    Gf = GSP_act;
    [Gf.u_return,Gf.u_status] = unix_g("rm -v " + Gf.fifo);
    mputl("quit", Gf.fd);
    mclose(Gf.fd);
    Gf.g_command = "quit";
    Gf.open = 0;
    GSP_fn(Gf.figure) = [];
    GSP_act = [];
endfunction


function gSaveParametricDataXYZ(fnam,x,y,z)
[sy,sx]=size(x);
s=ones(sy,sx,3);
s(:,:,1)=x;
s(:,:,2)=y;
s(:,:,3)=z;

fd = mopen(fnam,'wb');

for ii=1:sx,
    a = matrix(s(:,ii,:),sy,3);

    for jj=1:sy,
//   	mputl(strcat(string(a(jj,:)),' '),fd);
    	mputl(sprintf("%g %g %g\n",(a(jj,1)),(a(jj,2)),(a(jj,3))),fd);
    	end
    mputl("",fd);
    end
mclose(fd);
endfunction